# MySQL database creation template
# This is a template for install.php -- not for creating the database!
#
# $Id: schema.sql,v 1.4 2007/10/26 06:23:18 ilobachev Exp $

CREATE TABLE `@@DB_MAIN_PREFIX@@attachment` (
  attachment_id int(10) unsigned NOT NULL default '0',
  bug_id int(10) unsigned NOT NULL default '0',
  file_name char(255) NOT NULL default '',
  description char(255) NOT NULL default '',
  file_size bigint(20) unsigned NOT NULL default '0',
  mime_type char(30) NOT NULL default '',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (attachment_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@auth_group` (
  group_id int(10) unsigned NOT NULL default '0',
  group_name varchar(80) NOT NULL default '',
  locked tinyint(1) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (group_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@auth_perm` (
  perm_id int(10) unsigned NOT NULL default '0',
  perm_name varchar(80) NOT NULL default '',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (perm_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@auth_user` (
  user_id int(10) unsigned NOT NULL default '0',
  login char(40) NOT NULL default '',
  first_name char(40) NOT NULL default '',
  last_name char(40) NOT NULL default '',
  email char(60) NOT NULL default '',
  password char(40) NOT NULL default '',
  active tinyint(3) unsigned NOT NULL default '1',
  bug_list_fields text NOT NULL default '',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (user_id),
  UNIQUE KEY login (login)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug` (
  bug_id int(10) unsigned NOT NULL default '0',
  title varchar(100) NOT NULL default '',
  description text NOT NULL,
  url varchar(255) NOT NULL default '',
  severity_id tinyint(3) unsigned NOT NULL default '0',
  priority tinyint(3) unsigned NOT NULL default '0',
  status_id tinyint(3) unsigned NOT NULL default '0',
  resolution_id tinyint(3) unsigned NOT NULL default '0',
  database_id tinyint(3) unsigned NOT NULL default '0',
  site_id tinyint(3) unsigned NOT NULL default '0',
  assigned_to int(10) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  project_id int(10) unsigned NOT NULL default '0',
  version_id int(10) unsigned NOT NULL default '0',
  component_id int(10) unsigned NOT NULL default '0',
  os_id tinyint(3) unsigned NOT NULL default '0',
  browser_string varchar(255) NOT NULL default '',
  close_date bigint(20) unsigned NOT NULL default '0',
  closed_in_version_id int(10) unsigned NOT NULL default '0',
  to_be_closed_in_version_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY (bug_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug_cc` (
  bug_id int(10) unsigned NOT NULL default '0',
  user_id int(10) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (bug_id,user_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug_dependency` (
  bug_id int(10) unsigned NOT NULL default '0',
  depends_on int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (bug_id,depends_on)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug_group` (
  bug_id int(10) unsigned NOT NULL default '0',
  group_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (bug_id,group_id),
  KEY group_id (group_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug_history` (
  bug_id int(10) unsigned NOT NULL default '0',
  changed_field varchar(30) NOT NULL default '',
  old_value varchar(255) NOT NULL default '',
  new_value varchar(255) NOT NULL default '',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0'
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@bug_vote` (
  user_id int(10) unsigned NOT NULL default '0',
  bug_id int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (user_id, bug_id),
  KEY bug_id (bug_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@comment` (
  comment_id int(10) unsigned NOT NULL default '0',
  bug_id int(10) unsigned NOT NULL default '0',
  comment_text text NOT NULL,
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (comment_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@component` (
  component_id int(10) unsigned NOT NULL default '0',
  project_id int(10) unsigned NOT NULL default '0',
  component_name varchar(30) NOT NULL default '',
  component_desc text NOT NULL,
  owner int(10) unsigned NOT NULL default '0',
  active tinyint(1) NOT NULL default '1',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (component_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@configuration` (
  varname char(40) NOT NULL default '',
  varvalue char(255) NOT NULL default '',
  description char(255) NOT NULL default '',
  vartype char(20) NOT NULL default '',
  PRIMARY KEY  (varname)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@group_perm` (
  group_id int(10) unsigned NOT NULL default '0',
  perm_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (group_id,perm_id),
  KEY perm_id (perm_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@os` (
  os_id int(10) unsigned NOT NULL default '0',
  os_name char(30) NOT NULL default '',
  sort_order tinyint(3) unsigned NOT NULL default '0',
  regex char(40) NOT NULL default '',
  PRIMARY KEY  (os_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@project` (
  project_id int(10) unsigned NOT NULL default '0',
  project_name varchar(30) NOT NULL default '',
  project_desc text NOT NULL,
  active tinyint(1) NOT NULL default '1',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (project_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@project_group` (
  project_id int(10) unsigned NOT NULL default '0',
  group_id int(10) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (project_id,group_id),
  KEY group_id (group_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@resolution` (
  resolution_id int(10) unsigned NOT NULL default '0',
  resolution_name varchar(30) NOT NULL default '',
  resolution_desc text NOT NULL,
  sort_order tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (resolution_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@saved_query` (
  saved_query_id int(10) unsigned NOT NULL default '0',
  user_id int(10) unsigned NOT NULL default '0',
  saved_query_name varchar(40) NOT NULL default '',
  saved_query_string text NOT NULL,
  PRIMARY KEY  (saved_query_id,user_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@severity` (
  severity_id int(10) unsigned NOT NULL default '0',
  severity_name varchar(30) NOT NULL default '',
  severity_desc text NOT NULL,
  sort_order tinyint(3) unsigned NOT NULL default '0',
  severity_color varchar(10) NOT NULL default '#FFFFFF',
  PRIMARY KEY  (severity_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@status` (
  status_id int(10) unsigned NOT NULL default '0',
  status_name varchar(30) NOT NULL default '',
  status_desc text NOT NULL,
  sort_order tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (status_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@user_group` (
  user_id int(10) unsigned NOT NULL default '0',
  group_id int(10) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (user_id,group_id),
  KEY group_id (group_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@user_perm` (
  user_id int(10) unsigned NOT NULL default '0',
  perm_id int(10) unsigned NOT NULL default '0',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (user_id,perm_id),
  KEY perm_id (perm_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@user_pref` (
    user_id int(11) NOT NULL default '0',
    email_notices tinyint(1) NOT NULL default '1',
    saved_queries tinyint(1) NOT NULL default '1',
    PRIMARY KEY (user_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@version` (
  version_id int(10) unsigned NOT NULL default '0',
  project_id int(10) unsigned NOT NULL default '0',
  version_name char(10) NOT NULL default '',
  active tinyint(1) NOT NULL default '1',
  created_by int(10) unsigned NOT NULL default '0',
  created_date bigint(20) unsigned NOT NULL default '0',
  last_modified_by int(10) unsigned NOT NULL default '0',
  last_modified_date bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (version_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@database` (
  database_id tinyint(3) unsigned NOT NULL default '0',
  database_name varchar(40) NOT NULL default '',
  sort_order tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY (database_id)
) TYPE=MyISAM;

CREATE TABLE `@@DB_MAIN_PREFIX@@site` (
  site_id tinyint(3) unsigned NOT NULL default '0',
  site_name varchar(50) NOT NULL default '',
  sort_order tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY (site_id)
) TYPE=MyISAM;

#
# -- Insert initial data --
#

INSERT INTO `@@DB_MAIN_PREFIX@@auth_user`
(user_id, login, first_name, last_name, email, password)
values (1, '@@ADMIN_EMAIL@@', 'System', 'Admin', '@@ADMIN_EMAIL@@',
'@@ADMIN_PASSWORD@@');
CREATE TABLE `@@DB_MAIN_PREFIX@@auth_user_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@auth_user_seq` values (1);

# Start off with three user levels...
INSERT INTO `@@DB_MAIN_PREFIX@@auth_group` (group_id, group_name, locked) VALUES (1, 'Admin', 1);
INSERT INTO `@@DB_MAIN_PREFIX@@auth_group` (group_id, group_name, locked) VALUES (2, 'User', 1);
INSERT INTO `@@DB_MAIN_PREFIX@@auth_group` (group_id, group_name, locked) VALUES (3, 'Developer', 1);
CREATE TABLE `@@DB_MAIN_PREFIX@@auth_group_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@auth_group_seq` values (3);

# ... and only two permissions
INSERT INTO `@@DB_MAIN_PREFIX@@auth_perm` (perm_id, perm_name) VALUES (1, 'Admin');
INSERT INTO `@@DB_MAIN_PREFIX@@auth_perm` (perm_id, perm_name) VALUES (2, 'Editbug');

# Admins can do all the admin stuff and users can edit bugs
INSERT INTO `@@DB_MAIN_PREFIX@@group_perm` (group_id, perm_id) VALUES (1, 1);
INSERT INTO `@@DB_MAIN_PREFIX@@group_perm` (group_id, perm_id) VALUES (2, 2);

# And user_id 1 is an admin and a user
INSERT INTO `@@DB_MAIN_PREFIX@@user_group` (user_id, group_id) VALUES (1, 1);
INSERT INTO `@@DB_MAIN_PREFIX@@user_group` (user_id, group_id) VALUES (1, 2);

# Add user's prefs as default values for all users defined so far (only admin)
INSERT INTO `@@DB_MAIN_PREFIX@@user_pref` (user_id) SELECT USER_ID FROM `@@DB_MAIN_PREFIX@@auth_user`;

INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('INSTALL_URL','@@ROOT_URL@@','The base URL of the phpBugTracker installation','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('JPGRAPH_PATH','','If not in the include path.  This is the file path on the web server, not a URL.','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('CVS_WEB','http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/phpbt/phpbt/','Location of your cvs web interface (see format_comments() in bug.php)','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('ADMIN_EMAIL','@@ADMIN_EMAIL@@','The email address used in correspondence from the bug tracker','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('ENCRYPT_PASS','0','Whether to store passwords encrypted.  <b>Warning:</b> Changing this after users have been created will result in their being unable to login.','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('USE_JPGRAPH','','Whether to show some reports as images','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('MASK_EMAIL','1','Should email addresses have . changed to ''dot'' and @ change to ''at''?','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('HIDE_EMAIL','1','Should email addresses be hidden for those not logged in?','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('USE_SEVERITY_COLOR','1','Should the query list use the severity colors as the row background color (like SourceForge)','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('EMAIL_IS_LOGIN','1','Whether to use email addresses as logins','bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('STRICT_UPDATING', '0', 'Only the bug reporter, bug owner, managers, and admins can change a bug', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('NEW_ACCOUNTS_DISABLED', '0', 'Only admins can create new user accounts - newaccount.php is disabled', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('RECALL_LOGIN', '0', 'Enable use of cookies to store username between logins', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('SHOW_PROJECT_SUMMARIES', '1', 'Itemize bug stats by project on the home page', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('FORCE_LOGIN', '0', 'Force users to login before being able to use the bug tracker', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('PROMOTE_VOTES', 5, 'The number of votes required to promote a bug from Unconfirmed to New (Set to 0 to disable promotions by voting)', 'string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('MAX_USER_VOTES', 5, 'The maximum number of votes a user can cast across all bugs (Set to 0 to have no limit)', 'string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('ATTACHMENT_PATH','attachments','Sub-dir of the INSTALLPATH - Needs to be writeable by the web process','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('THEME','default','Which set of templates to use','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('ATTACHMENT_MAX_SIZE','2097152','Maximum size (in bytes) of an attachment. This will not override the settings in php.ini if php.ini has a lower limit.','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('DATE_FORMAT','m-d-Y','See the <a href="http://www.php.net/date" target="_new">date page</a> in the PHP manual for more info','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('TIME_FORMAT','g:i A','See the <a href="http://www.php.net/date" target="_new">date page</a> in the PHP manual for more info','string');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('LANGUAGE','en','The language file to use for warning and error messages','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('STYLE', 'default', 'The CSS file to use (color scheme)', 'multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('SEND_MIME_EMAIL', '1', 'Whether to use MIME quoted-printable encoded emails or not', 'bool');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('BUG_UNCONFIRMED','1','The status to assign a bug when it is first submitted.','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('BUG_PROMOTED','2','The status to assign a bug when it is promoted (if enabled).','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('BUG_ASSIGNED','3','The status to assign a bug when it is assigned.','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('BUG_REOPENED','4','The status to assign a bug when it is reopened.','multi');
INSERT INTO `@@DB_MAIN_PREFIX@@configuration` VALUES ('BUG_CLOSED','7','The status to assign a bug when it is closed.','multi');

INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (1,'All',1,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (2,'Windows 3.1',2,'/Mozilla.*\\(Win16.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (3,'Windows 95',3,'/Mozilla.*\\(.*;.*; 32bit.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (4,'Windows 98',4,'/Mozilla.*\\(Win98.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (5,'Windows ME',5,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (6,'Windows 2000',6,'/Mozilla.*Windows NT 5.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (7,'Windows NT',7,'/Mozilla.*\\(Windows.*NT/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (8,'Mac System 7',8,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (9,'Mac System 7.5',9,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (10,'Mac System 7.6.1',10,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (11,'Mac System 8.0',11,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (12,'Mac System 8.5',12,'/Mozilla.*\\(.*;.*; 68K.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (13,'Mac System 8.6',13,'/Mozilla.*\\(.*;.*; PPC.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (14,'Mac System 9.0',14,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (15,'Mac OS X',15,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (16,'Linux',16,'/Mozilla.*\\(.*;.*; Linux.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (17,'BSDI',17,'/Mozilla.*\\(.*;.*; BSD\\/OS.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (18,'FreeBSD',18,'/Mozilla.*\\(.*;.*; FreeBSD.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (19,'NetBSD',19,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (20,'OpenBSD',20,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (21,'AIX',21,'/Mozilla.*\\(.*;.*; AIX.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (22,'BeOS',22,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (23,'HP-UX',23,'/Mozilla.*\\(.*;.*; HP-UX.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (24,'IRIX',24,'/Mozilla.*\\(.*;.*; IRIX.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (25,'Neutrino',25,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (26,'OpenVMS',26,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (27,'OS/2',27,'');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (28,'OSF/1',28,'/Mozilla.*\\(.*;.*; OSF.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (29,'Solaris',29,'/Mozilla.*\\(.*;.*; SunOS 5.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (30,'SunOS',30,'/Mozilla.*\\(.*;.*; SunOS.*\\)/');
INSERT INTO `@@DB_MAIN_PREFIX@@os` VALUES (31,'other',31,'');
CREATE TABLE `@@DB_MAIN_PREFIX@@os_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@os_seq` values (31);

INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (1,'Fixed','Bug was eliminated',1);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (2,'Not a bug','It''s not a bug -- it''s a feature!',2);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (3,'Won''t Fix','This bug will stay',3);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (4,'Deferred','We''ll get around to it later',4);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (5,'Works for me','Can''t replicate the bug',5);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution` VALUES (6,'Duplicate','',6);
CREATE TABLE `@@DB_MAIN_PREFIX@@resolution_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@resolution_seq` values (6);

INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (1,'Unassigned','Default bug creation',1,'#dadada');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (2,'Idea','Ideas for further development',2,'#dad0d0');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (3,'Feature Request','Requests for specific features',3,'#dacaca');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (4,'Annoyance','Cosmetic problems or bugs not affecting performance',4,'#dac0c0');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (5,'Content','Non-functional related bugs, such as text content',5,'#dababa');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (6,'Significant','A bug affecting the intended performance of the product',6,'#dab0b0');
INSERT INTO `@@DB_MAIN_PREFIX@@severity` VALUES (7,'Critical','A bug severe enough to prevent the release of the product',7,'#daaaaa');
CREATE TABLE `@@DB_MAIN_PREFIX@@severity_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@severity_seq` values (7);

INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (1,'Unconfirmed','Reported but not confirmed',1);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (2,'New','A new bug',2);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (3,'Assigned','Assigned to a developer',3);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (4,'Reopened','Closed but opened again for further inspection',4);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (5,'Resolved','Set by engineer with a resolution',5);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (6,'Verified','The resolution is confirmed by the reporter',6);
INSERT INTO `@@DB_MAIN_PREFIX@@status` VALUES (7,'Closed','The bug is officially squashed (QA)',7);
CREATE TABLE `@@DB_MAIN_PREFIX@@status_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@status_seq` values (7);

INSERT INTO `@@DB_MAIN_PREFIX@@database` VALUES (1,'Oracle 8.1.7',1);
INSERT INTO `@@DB_MAIN_PREFIX@@database` VALUES (2,'MySQL 3.23.49',2);
INSERT INTO `@@DB_MAIN_PREFIX@@database` VALUES (3,'PostgreSQL 7.1.3',3);
CREATE TABLE `@@DB_MAIN_PREFIX@@database_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@database_seq` values (3);

# Examples only
INSERT INTO `@@DB_MAIN_PREFIX@@site` VALUES (0,'All',1);
INSERT INTO `@@DB_MAIN_PREFIX@@site` VALUES (1,'Production - location 1',2);
INSERT INTO `@@DB_MAIN_PREFIX@@site` VALUES (2,'Production - location 2',3);
INSERT INTO `@@DB_MAIN_PREFIX@@site` VALUES (3,'Test site - location 1',4);
INSERT INTO `@@DB_MAIN_PREFIX@@site` VALUES (4,'Test site - location 2',5);
CREATE TABLE `@@DB_MAIN_PREFIX@@site_seq` (id int unsigned auto_increment not null primary key);
INSERT INTO `@@DB_MAIN_PREFIX@@site_seq` values (4);
